package network;



import java.util.ArrayList;

import shared.constant.IConstants;

import shared.network.CNetworkContainer;
import shared.object.CClient;



public class CAgentPerformer {

	private CClient client;
	private CAgentQueueSender itsAgentQueue;


	public CAgentPerformer(CClient client, boolean isBanned){
		this.client = client;		
		itsAgentQueue = new CAgentQueueSender(CConstants.getServerIP(), CConstants.getServerPort(), CConstants.getRessourceQueue());
	}



	public void restartJMSConnection(){
		itsAgentQueue = new CAgentQueueSender(CConstants.getServerIP(), CConstants.getServerPort(), CConstants.getRessourceQueue());
	}

	public CClient getClient() {
		return client;
	}


	public void stop(){
		this.itsAgentQueue.stop();
	}

	private String getLogHeader(){
		return "[CAgentPerformer]";
	}



	//------------------------------------les fonctions de simlation------------------//


	public synchronized void simuleQkiOK () {
		new Thread(new Runnable() {
			public void run () {
				System.out.println(getLogHeader() + " -- simule QKIOK --");
			
				boolean result = false;

				// packing the password
				CNetworkContainer aC_QKIOK = new CNetworkContainer(IConstants.QKIOK,
						client, new ArrayList<Object>());

				// sending the command
				result = itsAgentQueue.send(aC_QKIOK);


				System.out.println(getLogHeader() + "-- end of QKIOK (" +result + ")--"); 
			}
		}).start();
	}
	
	
}
