package network;


import com.sun.messaging.Queue;

import shared.network.CNetworkContainer;

import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.ObjectMessage;


public class CAgentQueueSender extends CAbstractJMSCommunicator {
 
	
    /* Server's  Messaging Queue destination */
    private Queue itsDestination;

    //~ Constructors -----------------------------------------------------------

    public CAgentQueueSender (String serverIP, String serverPort, String serverQueue) {
    	init(serverIP, serverPort, serverQueue);
    }

    
    
    
    public void init (String serverIP, String serverPort, String serverQueue) {
        try {
            itsServerIP = serverIP;
            itsServerPort = serverPort;
            createPersistentConnection(serverQueue);
    
        } catch (Exception ex) {
        	System.out.println("CAgentQueueSender.init: "+ex.getMessage());
        }
    }

 
    public void tryReconnect(){
    	try {
    		startReconnectThread();
    		synchronized(this){
    			wait(5000);
    		}
    		
    	} catch (Exception ex) {
	    	System.out.println("CAgentTopicSubscriber.tryReconnect: "+ex.getMessage());
	        return;
	    }
    }
    
    
    
    public boolean send (CNetworkContainer theContainer) {
        ObjectMessage aObjMessage;

        try {

            System.out.println("############### SEND MESSAGE ##############");
        	
        	if(itsJMSSession==null){
        		synchronized (this) {
        			tryReconnect();
					if(itsJMSSession==null)
						return false;
				}
        	}
        	
            //Create the Message
            aObjMessage = itsJMSSession.createObjectMessage(theContainer);
            //Send the message
            System.out.println("message=" + theContainer);

            MessageProducer producer = itsJMSSession.createProducer(itsDestination);
            
           
            
            //itsProducer.send(aObjMessage);
            producer.send(aObjMessage);
            
            //closeproducer
            producer.close();
            System.out.println("###########################################");
            return true;
        } catch (JMSException exJMS) {
        	System.out.println("CAgentQueueSender.init: "+exJMS.getMessage());
            return false;
        }
    }

}

